{ KOL MCK } // Do not remove this line!
const TBOpen = 0;
const TBSave = 1;
const TBDisplaySize = 3;
const TBKeyboard = 4;
const TBPokes = 5;
const TBPause = 7;
const TBSpeed = 8;
const TBSoundOn = 9;
const TBSoundOff = 10;
const TBPlayTape = 12;

const N1 = 0;
const mmOpen = 1;
const mmOpenPokes = 2;
const mmSave = 3;
const mmSaveAs = 4;
const N5 = 5;
const mmS128 = 6;
const mmS48 = 7;
const N31 = 8;
const mmReset = 10;
const N18 = 12;
const N33 = 14;
const N11 = 15;
const mmPause = 16;
const mmMinimize2Tray = 17;
const mmAutoPause = 18;
const mmJoyOn = 20;
const N21 = 21;
const mmKeybRemap = 22;
const N14 = 24;
const mmSpeed50 = 25;
const mmSpeed70 = 26;
const mmSpeed100 = 27;
const mmSpeed150 = 28;
const mmSpeed200 = 29;
const mmSpeed300 = 30;
const mmSpeed400 = 31;
const mmSpeed500 = 32;
const mmSpeed600 = 33;
const mmSpeed700 = 34;
const mmSpeed800 = 35;
const mmIntEmulated = 37;
const mmInt40 = 38;
const mmInt50 = 39;
const mmInt60 = 40;
const N25 = 41;
const mmPriorityAbove = 42;
const mmPriorityNormal = 43;
const mmSound = 44;
const mmSoundOn = 45;
const mmDirectSound = 47;
const mmPCSpeaker = 48;
const mmTape = 49;
const mmTapePlay = 50;
const mmAutoPlayTape = 51;
const mmTapeFastLoad = 53;
const mmFlashTape = 54;
const mmDoublePilot = 55;
const mmTapeCatalog = 57;
const mmTRDOS = 58;
const mmTRDOS_on = 59;
const mmDiskBrowser = 60;
const N2 = 61;
const mmViewToolbar = 62;
const mmDebug = 63;
const N27 = 64;
const mmKeyboard = 65;
const mmPokes = 66;
const mmAdjustColors = 67;
const N16 = 69;
const mmDirectX = 70;
const mmGUI = 71;
const mmInterlace = 72;
const N3 = 73;
const N4 = 74;
const N6 = 75;
const N7 = 76;
const mmReduce = 78;
const mmIncrease = 79;
const mmProportional = 80;
const N15 = 81;
const mmBorderNone = 82;
const mmBorderThin = 83;
const mmBorderSmall = 84;
const mmBorderMedium = 85;
const mmBorderThick = 86;
const N9 = 87;
const mmRRmax = 88;
const mmRRnormal = 89;
const mmRRslow = 90;
const mmRRrare = 91;
const mmRRfullscrNormal = 93;
const mmPortFF = 94;
const N10 = 95;


procedure NewForm1( var Result: PForm1; AParent: PControl );
begin

  {$IFDEF KOLCLASSES}
  Result := PForm1.Create;
  {$ELSE OBJECTS}
  New( Result, Create );
  {$ENDIF KOL CLASSES/OBJECTS}
  Result.Form := NewForm( AParent, 'Form1' ).SetPosition( 461, 314 ).SetClientSize( 361, 298 ).SupportMnemonics;
  Result.Form.Add2AutoFree( Result );
      Result.Form.OnMessage := Result.KOLForm1Message;
      Result.Form.OnClose := Result.KOLForm1Close;
      Result.Form.OnResize := Result.KOLForm1Resize;
      Result.Form.OnShow := Result.KOLForm1Show;
      Result.Form.OnDropFiles := Result.KOLForm1DropFiles;
      Result.Form.OnDestroy := Result.KOLForm1Destroy;

    Result.MainMenu1 := NewMenu( Result.Form, 0, [ '&File', '('
      , '&Open'+#9+'F3', 'Open &Pokes...', '&Save'+#9+'F2'
      , 'Save &As'+#9+'Alt+F2', '&New', '(', 'Spectrum-&128'
      , 'Spectrum-&48', 'Custom &ROM Image...', '-' + ''
      , '&Reset'+#9+'F11', ')', '-' + '', 'Path To PKUN&ZIP'
      , '-' + '', 'E&xit', ')', '&Control', '('
      , '&Pause/Resume'+#9+'F9'
      , 'Pause And &Minimize To Tray'+#9+'Esc'
      , '+' + '&Auto Pause', '-' + ''
      , '+' + '&Joystick On'+#9+'Alt+J'
      , 'Joystick Configuration', '&Keyboard Remapping'
      , '-' + '', '&Speed', '('
      , '-!' + '50% (1.75MHz)^Alt+Num[ * ] to fast switch'
      , '-!' + '70% (2.45MHz)'
      , '+!' + '100% (3.5MHz) ^NUM[ * ] to fast switch'
      , '-!' + '150% (5.25MHz)'
      , '-!' + '200% (7MHz)^NUM[ * ] to fast switch'
      , '-!' + '300% (10.5MHz)', '-!' + '400% (14MHz)'
      , '-!' + '500% (17.5MHz)', '-!' + '600% (21MHz)'
      , '-!' + '700% (24.5MHz)'
      , '-!' + '800% (28MHz)^Alt+Num[ * ] to fast switch'
      , '-' + '', '+!' + 'Int 50Hz &Emulated'
      , '-!' + 'Int 40Hz Fixed', '-!' + 'Int 50Hz Fixed'
      , '-!' + 'Int 60Hz Fixed', ')', 'Priorit&y', '('
      , '-!' + '&Above Normal', '+!' + '&Normal', ')', 'S&ound'
      , '(', '+' + 'Sound &On', '-' + '', '+!' + '&Direct Sound'
      , '-!' + '&PC Speaker', ')', '&Tape', '('
      , '&Play/Stop'+#9+'Alt+P', '+' + '&Auto Play/Stop'
      , '-' + '', '+' + '&Fast Load'+#9+'/', '+' + 'F&lash Load'
      , '+' + '&Double Pilot', '-' + ''
      , '&Catalog Show'+#9+'Alt+T', ')', 'TR-&DOS', '('
      , '+' + 'TR-DOS &On', 'Disk &Browser'+#9+'Alt+D', ')', ')'
      , '&View', '(', '+' + '&Toolbar', '&Debug Window'+#9+'F12'
      , '&Assembler', '&Keyboard'+#9+'Alt+K'
      , '&Pokes'+#9+'Alt+O', 'Adjust &Colors', '-' + ''
      , 'Display &Mode', '('
      , '-!' + '&DirectX Full-Screen^Alt+Enter'
      , '+!' + '&GUI^Alt+Enter', ')'
      , '+' + '&Interlaced in Full Screen'+#9+'Alt+I'
      , 'Display &Size', '(', '1:1 (256x192 main screen)'
      , '2:1 (512x384 main screen)', '3:1 (768x576 main screen)'
      , '-' + '', '&Reduce^NUM[ - ]', '&Increase^NUM[ + ]', ')'
      , '+' + 'Pr&oportional Size', 'Display &Border', '('
      , '-!' + '&None', '-!' + '&Thin (8 pts)'
      , '-!' + '&Small (16 pts)', '+!' + '&Medium (24 pts)'
      , '-!' + 'Thic&k (40 pts)', ')', 'Refresh &Rate', '('
      , '+!' + '&Maximum (50 frames/emulated sec)'
      , '-!' + '&Normal (50 frames/sec)'
      , '-!' + '&Slower (25 frames/sec)'
      , '-!' + '&Rare (10 frames/sec)', '-' + ''
      , '+' + 'Normal in &Full Screen', ')'
      , '+' + 'Emulation IN &FF', ')', '&About', '' ], nil );
    Result.MainMenu1.AssignEvents( 1, [ Result.KOLForm1mmOpenMenu ] );
    Result.MainMenu1.ItemAccelerator[ 1 ] := MakeAccelerator( FVIRTKEY, VK_F3 );
    Result.MainMenu1.AssignEvents( 2, [ Result.KOLForm1mmOpenPokesMenu ] );
    Result.MainMenu1.AssignEvents( 3, [ Result.KOLForm1mmSaveMenu ] );
    Result.MainMenu1.ItemAccelerator[ 3 ] := MakeAccelerator( FVIRTKEY, VK_F2 );
    Result.MainMenu1.AssignEvents( 4, [ Result.MainMenu1mmSaveAsMenu ] );
    Result.MainMenu1.ItemAccelerator[ 4 ] := MakeAccelerator( FVIRTKEY or FALT, VK_F2 );
    Result.MainMenu1.AssignEvents( 6, [ Result.MainMenu1mmS128Menu ] );
    Result.MainMenu1.AssignEvents( 7, [ Result.MainMenu1mmS48Menu ] );
    Result.MainMenu1.AssignEvents( 8, [ Result.KOLForm1N31Menu ] );
    Result.MainMenu1.AssignEvents( 10, [ Result.MainMenu1mmResetMenu ] );
    Result.MainMenu1.ItemAccelerator[ 10 ] := MakeAccelerator( FVIRTKEY, VK_F11 );
    Result.MainMenu1.AssignEvents( 12, [ Result.MainMenu1N18Menu ] );
    Result.MainMenu1.AssignEvents( 14, [ Result.MainMenu1N33Menu ] );
    Result.MainMenu1.AssignEvents( 16, [ Result.MainMenu1mmPauseMenu ] );
    Result.MainMenu1.ItemAccelerator[ 16 ] := MakeAccelerator( FVIRTKEY, VK_F9 );
    Result.MainMenu1.AssignEvents( 17, [ Result.MainMenu1mmMinimize2TrayMenu ] );
    Result.MainMenu1.ItemAccelerator[ 17 ] := MakeAccelerator( FVIRTKEY, VK_ESCAPE );
    Result.MainMenu1.AssignEvents( 18, [ Result.MainMenu1mmAutoPauseMenu ] );
    Result.MainMenu1.AssignEvents( 20, [ Result.MainMenu1mmJoyOnMenu ] );
    Result.MainMenu1.ItemAccelerator[ 20 ] := MakeAccelerator( FVIRTKEY or FALT, $4A );
    Result.MainMenu1.AssignEvents( 21, [ Result.MainMenu1N21Menu ] );
    Result.MainMenu1.AssignEvents( 22, [ Result.MainMenu1mmKeybRemapMenu ] );
    Result.MainMenu1.AssignEvents( 25, [ Result.MainMenu1mmSpeed50Menu ] );
    Result.MainMenu1.AssignEvents( 26, [ Result.KOLForm1mmSpeed70Menu ] );
    Result.MainMenu1.AssignEvents( 27, [ Result.MainMenu1mmSpeed100Menu ] );
    Result.MainMenu1.AssignEvents( 28, [ Result.MainMenu1mmSpeed150Menu ] );
    Result.MainMenu1.AssignEvents( 29, [ Result.MainMenu1mmSpeed200Menu ] );
    Result.MainMenu1.AssignEvents( 30, [ Result.MainMenu1mmSpeed300Menu ] );
    Result.MainMenu1.AssignEvents( 31, [ Result.MainMenu1mmSpeed400Menu ] );
    Result.MainMenu1.AssignEvents( 32, [ Result.MainMenu1mmSpeed500Menu ] );
    Result.MainMenu1.AssignEvents( 33, [ Result.MainMenu1mmSpeed600Menu ] );
    Result.MainMenu1.AssignEvents( 34, [ Result.MainMenu1mmSpeed700Menu ] );
    Result.MainMenu1.AssignEvents( 35, [ Result.MainMenu1mmSpeed800Menu ] );
    Result.MainMenu1.ItemVisible[ 36 ] := False;
    Result.MainMenu1.ItemVisible[ 37 ] := False;
    Result.MainMenu1.AssignEvents( 37, [ Result.MainMenu1mmIntEmulatedMenu ] );
    Result.MainMenu1.ItemVisible[ 38 ] := False;
    Result.MainMenu1.AssignEvents( 38, [ Result.KOLForm1mmInt40Menu ] );
    Result.MainMenu1.ItemVisible[ 39 ] := False;
    Result.MainMenu1.AssignEvents( 39, [ Result.KOLForm1mmInt50Menu ] );
    Result.MainMenu1.ItemVisible[ 40 ] := False;
    Result.MainMenu1.AssignEvents( 40, [ Result.KOLForm1mmInt60Menu ] );
    Result.MainMenu1.AssignEvents( 42, [ Result.MainMenu1mmPriorityAboveMenu ] );
    Result.MainMenu1.AssignEvents( 43, [ Result.MainMenu1mmPriorityNormalMenu ] );
    Result.MainMenu1.AssignEvents( 45, [ Result.MainMenu1mmSoundOnMenu ] );
    Result.MainMenu1.AssignEvents( 47, [ Result.KOLForm1mmDirectSoundMenu ] );
    Result.MainMenu1.AssignEvents( 48, [ Result.KOLForm1mmPCSpeakerMenu ] );
    Result.MainMenu1.AssignEvents( 50, [ Result.MainMenu1mmTapePlayMenu ] );
    Result.MainMenu1.ItemAccelerator[ 50 ] := MakeAccelerator( FVIRTKEY or FALT, $50 );
    Result.MainMenu1.AssignEvents( 51, [ Result.MainMenu1mmAutoPlayTapeMenu ] );
    Result.MainMenu1.AssignEvents( 53, [ Result.MainMenu1mmTapeFastLoadMenu ] );
    Result.MainMenu1.ItemAccelerator[ 53 ] := MakeAccelerator( FVIRTKEY, VK_DIVIDE );
    Result.MainMenu1.AssignEvents( 54, [ Result.MainMenu1mmFlashTapeMenu ] );
    Result.MainMenu1.AssignEvents( 57, [ Result.MainMenu1mmTapeCatalogMenu ] );
    Result.MainMenu1.ItemAccelerator[ 57 ] := MakeAccelerator( FVIRTKEY or FALT, $54 );
    Result.MainMenu1.AssignEvents( 59, [ Result.KOLForm1mmTRDOS_onMenu ] );
    Result.MainMenu1.AssignEvents( 60, [ Result.MainMenu1mmDiskBrowserMenu ] );
    Result.MainMenu1.ItemAccelerator[ 60 ] := MakeAccelerator( FVIRTKEY or FALT, $44 );
    Result.MainMenu1.AssignEvents( 62, [ Result.MainMenu1mmViewToolbarMenu ] );
    Result.MainMenu1.AssignEvents( 63, [ Result.MainMenu1mmDebugMenu ] );
    Result.MainMenu1.ItemAccelerator[ 63 ] := MakeAccelerator( FVIRTKEY, VK_F12 );
    Result.MainMenu1.AssignEvents( 64, [ Result.MainMenu1N27Menu ] );
    Result.MainMenu1.AssignEvents( 65, [ Result.mmKeyboardClick ] );
    Result.MainMenu1.ItemAccelerator[ 65 ] := MakeAccelerator( FVIRTKEY or FALT, $4B );
    Result.MainMenu1.ItemEnabled[ 66 ] := False;
    Result.MainMenu1.AssignEvents( 66, [ Result.MainMenu1mmPokesMenu ] );
    Result.MainMenu1.ItemAccelerator[ 66 ] := MakeAccelerator( FVIRTKEY or FALT, $4F );
    Result.MainMenu1.AssignEvents( 67, [ Result.MainMenu1mmAdjustColorsMenu ] );
    Result.MainMenu1.AssignEvents( 70, [ Result.MainMenu1mmDirectXMenu ] );
    Result.MainMenu1.AssignEvents( 71, [ Result.KOLForm1mmGUIMenu ] );
    Result.MainMenu1.AssignEvents( 72, [ Result.MainMenu1mmInterlaceMenu ] );
    Result.MainMenu1.ItemAccelerator[ 72 ] := MakeAccelerator( FVIRTKEY or FALT, $49 );
    Result.MainMenu1.AssignEvents( 74, [ Result.MainMenu1N4Menu ] );
    Result.MainMenu1.AssignEvents( 75, [ Result.MainMenu1N6Menu ] );
    Result.MainMenu1.AssignEvents( 76, [ Result.MainMenu1N7Menu ] );
    Result.MainMenu1.AssignEvents( 78, [ Result.KOLForm1mmReduceMenu ] );
    Result.MainMenu1.AssignEvents( 79, [ Result.KOLForm1mmIncreaseMenu ] );
    Result.MainMenu1.AssignEvents( 80, [ Result.MainMenu1mmProportionalMenu ] );
    Result.MainMenu1.AssignEvents( 82, [ Result.MainMenu1mmBorderNoneMenu ] );
    Result.MainMenu1.AssignEvents( 83, [ Result.MainMenu1mmBorderThinMenu ] );
    Result.MainMenu1.AssignEvents( 84, [ Result.MainMenu1mmBorderSmallMenu ] );
    Result.MainMenu1.AssignEvents( 85, [ Result.MainMenu1mmBorderMediumMenu ] );
    Result.MainMenu1.AssignEvents( 86, [ Result.MainMenu1mmBorderThickMenu ] );
    Result.MainMenu1.AssignEvents( 88, [ Result.KOLForm1mmRRmaxMenu ] );
    Result.MainMenu1.AssignEvents( 89, [ Result.KOLForm1mmRRnormalMenu ] );
    Result.MainMenu1.AssignEvents( 90, [ Result.KOLForm1mmRRslowMenu ] );
    Result.MainMenu1.AssignEvents( 91, [ Result.KOLForm1mmRRrareMenu ] );
    Result.MainMenu1.ItemVisible[ 94 ] := False;
    Result.MainMenu1.AssignEvents( 94, [ Result.KOLForm1mmPortFFMenu ] );
    Result.MainMenu1.AssignEvents( 95, [ Result.KOLForm1N10Menu ] );

    Result.Thread1 := NewThread;
    Result.Thread1.OnExecute := Result.Thread1Execute;
  Result.Form.Add2AutoFree( Result.Thread1 );

    Result.Timer1 := NewTimer( 2500 );
  Result.Form.Add2AutoFree( Result.Timer1 );
      Result.Timer1.OnTimer := Result.Timer1Timer;

    Result.SaveDialog1 := NewOpenSaveDialog( 'Select File To Save State', '', [  ] );
      Result.SaveDialog1.Filter := 'EmuZWin shapshot (*.ezx)|*.ezx';
      Result.SaveDialog1.OpenDialog := FALSE;
      Result.SaveDialog1.DefExtension := 'ezx';
  Result.Form.Add2AutoFree( Result.SaveDialog1 );

      {$R Form1_TrayIcon1.RES}
    Result.TrayIcon1 := NewTrayIcon( Applet, 0 );
    Result.TrayIcon1.Active := FALSE;
    Result.TrayIcon1.Icon := LoadIcon( hInstance, 'ZFORM1_TRAYICON1' );
    Result.TrayIcon1.Tooltip := 'EmuZWin 2.0';
    Result.TrayIcon1.AutoRecreate := TRUE;
  Result.Form.Add2AutoFree( Result.TrayIcon1 );
      Result.TrayIcon1.OnMouse := Result.TrayIcon1Mouse;

    Result.OpenROMDialog := NewOpenSaveDialog( 'Select ROM Image', '', [  ] );
      Result.OpenROMDialog.Filter := 'Spectrum ROM Image 16K or 32K (*.rom)|*.rom|Any file 16K or 32K (*.*)|*.*';
      Result.OpenROMDialog.DefExtension := 'rom';
  Result.Form.Add2AutoFree( Result.OpenROMDialog );

    Result.OpenPokesDialog := NewOpenSaveDialog( 'Select POKes file to open', '', [  ] );
      Result.OpenPokesDialog.Filter := 'Pokes file (*.pok)|*.pok';
      Result.OpenPokesDialog.DefExtension := 'pok';
  Result.Form.Add2AutoFree( Result.OpenPokesDialog );
    // Result.Panel1.TabOrder = 0
    Result.Panel1 := NewPanel( Result.Form, esLowered ).SetAlign ( caClient );
    Result.Panel1.Border := 0;
    // Result.PaintBox1.TabOrder = 0
      Result.PaintBox1 := NewPaintBox( Result.Panel1 ).SetAlign ( caClient );
      Result.PaintBox1.Border := 2;
      Result.PaintBox1.Cursor := LoadCursor( hInstance, 'BLENDCURSOR' );
    // Result.ToolPanel.TabOrder = 1
    Result.ToolPanel := NewPanel( Result.Form, esNone ).SetAlign ( caTop ).SetSize( 0, 31 );
    Result.ToolPanel.Border := 0;
    Result.ToolPanel.MarginBottom := 2;
    // Result.Panel3.TabOrder = 1
      Result.Panel3 := NewPanel( Result.ToolPanel, esLowered ).SetAlign ( caBottom ).SetSize( 0, 2 );
      Result.Panel3.Border := 2;
    // Result.Toolbar1.TabOrder = 2
        {$R Form1_Toolbar1.res}
      Result.Toolbar1 := NewToolbar( Result.ToolPanel, caTop, [tboFlat], 0, [ ' ', ' ', '-', ' ', '- ', ' ', '-', '- ', '- ', '+ ', ' ', '-', '- ' ], [ 14, 15, -2, 27, 0, 1, -2, 2, 3, 4, 5, -2, 6 ] ).SetAlign ( caTop );
      Result.Toolbar1.MarginLeft := 284;
        Result.Toolbar1.TBBtnImgWidth := 16;
        Result.Toolbar1.TBAddBitmap( LoadMappedBitmapEx( Result.Toolbar1, hInstance, 'FORM1_TBBMP5000', [ clFuchsia, Color2RGB( clBtnFace ) ] ) );
        Result.Toolbar1.TBAddBitmap( THandle( -1 ) );
        Result.Toolbar1.TBAddBitmap( THandle( -5 ) );
        Result.Toolbar1.TBAddBitmap( THandle( -9 ) );
        Result.Toolbar1.TBSetTooltips( Result.Toolbar1.TBIndex2Item( 0 ), [ 'Open (F3)', 'Save (F2)', '-', 'Display Size (NUM[ + ]/NUM[ - ])', 'Keyboard (Alt+K)', 'Pokes (Alt+O)', '-', 'Pause', 'Normal/Double Speed (NUM[ * ])', 'Sound On/Off', 'Sound On/Off', '-', 'Play Tape' ] );
        Result.Toolbar1.TBAssignEvents( 0, [ Result.Toolbar1TBOpenClick, Result.Toolbar1TBSaveClick, nil, Result.Toolbar1TBDisplaySizeClick, Result.Toolbar1TBKeyboardClick, Result.Toolbar1TBPokesClick, nil, Result.Toolbar1TBPauseClick, Result.Toolbar1TBSpeedClick, Result.Toolbar1TBSoundOnClick, Result.Toolbar1TBSoundOnClick, nil, Result.Toolbar1TBPlayTapeClick ] );
      Result.Toolbar1.TBButtonEnabled[ 12 ] := FALSE;
      Result.Toolbar1.TBButtonVisible[ 10 ] := FALSE;
      Result.Toolbar1.TBButtonVisible[ 5 ] := FALSE;
    // Result.TapeProgressPanel.TabOrder = 0
        Result.TapeProgressPanel := NewPanel( Result.Toolbar1, esNone ).SetAlign ( caClient );
        Result.TapeProgressPanel.MarginTop := 2;
        Result.TapeProgressPanel.MarginBottom := 4;
    // Result.ProgressBar1.TabOrder = 0
          Result.ProgressBar1 := NewProgressBarEx( Result.TapeProgressPanel, [ pboSmooth ] ).SetAlign ( caClient );
          Result.ProgressBar1.Cursor := LoadCursor( 0, IDC_HAND );
      Result.PaintBox1.OnMouseDblClk := Result.PaintBox1MouseDblClk;
      Result.PaintBox1.OnMouseDown := Result.PaintBox1MouseDown;
      Result.PaintBox1.OnMouseMove := Result.PaintBox1MouseMove;
      Result.PaintBox1.OnMouseUp := Result.PaintBox1MouseUp;
      Result.PaintBox1.OnPaint := Result.PaintBox1Paint;
      Result.ProgressBar1.OnMouseDown := Result.ProgressBar1MouseDown;
    Result.Timer1.Enabled := True;
      Result.SaveDialog1.WndOwner := Result.Form.GetWindowHandle;
      Result.OpenROMDialog.WndOwner := Result.Form.GetWindowHandle;
      Result.OpenPokesDialog.WndOwner := Result.Form.GetWindowHandle;
    Result.Form.CenterOnParent;
    Result.Form.MinimizeNormalAnimated;
    Result.KOLForm1FormCreate( Result );

end;

